



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Unity3d Shader开发（三）Pass（Color, Material, Lighting ）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Unity3d Shader开发（三）Pass（Color, Material, Lighting ）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 11:09:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>材质和灯光参数被用于控制内置顶点光照。顶点光照是Direct3D/OpenGL标准的按每顶点计算的光照模型。光照打开时，光照受材质块，颜色材质和平行高光命令的影响。</p>
<p>每像素光照常被实现为自定义顶点/片面程序，并且不使用顶点光照。这种情况下，你不会使用到任何在这里描述的命令，相反，在你完成光照，贴图和任何其他动作时，你需要定义自己的<a href="http://game.ceeger.com/Components/SL-ShaderPrograms.html" rel="external nofollow noreferrer">vertex and fragment programs</a>&nbsp;。</p>
<p><img referrerpolicy="no-referrer"src="http://game.ceeger.com/Components/Images/SL-Material-0.jpg" /></p>
<p>顶点颜色和灯光是对任何已渲染过后的几何体所添加的第一步效果。这个操作处在顶点级别，用于计算在纹理被应用之前被使用的基础颜色。</p>
<h2>Syntax 语法</h2>
<p>顶层命令控制是否采用固定函数光照，和一些控制选项。主要是在Material Block描述这些设置，细节如下。</p>
<dl>
<dt><strong>Color</strong>&nbsp;<em>Color</em></dt>
<dd>设定对象的纯色。颜色即可以是括号中的四值（RGBA），也可以是被方框包围的颜色属性名。</dd>
<dt><strong>Material</strong>&nbsp;<strong>{</strong>&nbsp;<em>Material Block</em>&nbsp;<strong>}</strong></dt>
<dd>材质块被用于定义对象的材质属性。</dd>
<dt><strong>Lighting</strong>&nbsp;On | Off</dt>
<dd>定义材质块中的设定是否有效，你必须使用Lighting On 命令开启光照，而颜色则通过Color命令直接给出。</dd>
<dt><strong>SeparateSpecular</strong>&nbsp;On | Off</dt>
<dd>这个命令会添加高光光照到着色器通道的末尾，因此贴图对高光没有影响。只在光照开启时有效。</dd>
<dt><strong>ColorMaterial</strong>&nbsp;AmbientAndDiffuse | Emission</dt>
<dd>使用每顶点的颜色替代材质中的颜色集。AmbientAndDiffuse 替代材质的阴影光和漫反射值;Emission 替代 材质中的光发射值。</dd>
</dl>
<h3>Material Block 材质块</h3>
<p>包含材质如何和光线产生作用的设定。这些属性都是可以被忽略的，默认为值都被设定为黑色（不产生作用）</p>
<dl>
<dt><strong>Diffuse</strong>&nbsp;<em>Color</em></dt>
<dd>漫反射颜色构成。这是对象的基本颜色。</dd>
<dt><strong>Ambient</strong>&nbsp;<em>Color</em></dt>
<dd>环境色颜色构成.这是当对象被RenderSettings. 中设定的环境色所照射时对象所表现的颜色。</dd>
<dt><strong>Specular</strong>&nbsp;<em>Color</em></dt>
<dd>对象反射高光的颜色。</dd>
<dt><strong>Shininess</strong>&nbsp;<em>Number</em></dt>
<dd>加亮时的光泽度，在0和1之间。0的时候你会发现更大的高亮也看起来像漫反射光照，1的时候你会获得一个细微的亮斑。</dd>
<dt><strong>Emission</strong>&nbsp;<em>Color</em></dt>
<dd>自发光颜色，当不被任何光照所照到时，对象的颜色</dd>
</dl>
<p>打在对象上的完整光照颜色最终是：</p>
<div>
<pre class="prettyprint linenums">  Ambient * RenderSettings ambient setting +<br />
  (Light Color * Diffuse + Light Color * Specular) + Emission</pre>
</div>
<p>方程式的灯光部分（带括号）对所有打在对象上的光线重复使用。典型情况是你希望将漫反射和阴影光保持一致（所有内置Unity着色器都是如此）。</p>
<hr />
<p><strong>实例</strong></p>
<p>渲染的对象将保持纯红：</p>
<div>
<pre class="prettyprint linenums">Shader "Solid Red" {<br />
    SubShader {<br />
        Pass { Color (,,,) }<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/558630/201309/26173826-7de0e1b4ddd143f28a7d8c2213f16dd7.png" /></p>
<p>将对象涂成白色并应用顶点光照的标准着色器：</p>
<div>
<pre class="prettyprint linenums">Shader "VertexLit White" {<br />
    SubShader {<br />
        Pass {<br />
            Material {<br />
                Diffuse (,,,) //对象的基本颜色为白色<br />
                　　　　  Ambient (,,,) //环境色所照射时对象所表现的颜色为红色<br />
            }<br />
            Lighting On<br />
        }<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/558630/201309/26173838-4de46284853840f38b247af241032add.png" /></p>
<p>使材质颜色作为材质检视面板可视的属性的着色器扩展版本:</p>
<div>
<pre class="prettyprint linenums">Shader "Custom/MyShader" {<br />
    Properties {<br />
        _Color ("Main Color", COLOR) = (,,,)<br />
        _AmbientColor("Ambient Color",COLOR) =(,,,)<br />
    }<br />
    SubShader {<br />
        Pass {<br />
            Material {<br />
                Diffuse [_Color]<br />
                Ambient [_AmbientColor]<br />
            }<br />
            Lighting On<br />
        }<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/558630/201309/26174621-ad03a22a419b43c5bd5a53c3e4b3ab55.jpg" /></p>
<p>最后，一个完全齐备的顶点光照着色器（参考<a href="http://game.ceeger.com/Components/SL-SetTexture.html" rel="external nofollow noreferrer">SetTexture</a>&nbsp;页面）</p>
<div>
<pre class="prettyprint linenums">Shader "Custom/MyShader" {<br />
 　　Properties {<br />
        　　　　　　_Color ("Main Color", Color) = (,,,)<br />
        　　　　　　_SpecColor ("Spec Color", Color) = (,,,)<br />
        　　　　　　_Emission ("Emmisive Color", Color) = (,,,)<br />
        　　　　　　_Shininess ("Shininess", Range(0.01, )) = 0.7<br />
        　　　　　　_MainText("Base (RGB)", 2D) = "white" {}<br />
    　　　　　}<br />
   　 SubShader {<br />
        　　　　　　Pass {    // 渲染通道的列表，材质块<br />
            　　　　　　　　Material<br />
            　　　　　　　　{<br />
                　　　　　　　　Diffuse [_Color]    // 对象的基本颜色。<br />
                　　　　　　　　Ambient [_Color]    // 环境色所照射时对象所表现的颜色<br />
                　　　　　　　　Shininess [_Shininess]    // 亮度设置,加亮时的光泽度<br />
                　　　　　　　　Specular [_SpecColor]    // 对象反射高光的颜色<br />
                　　　　　　　　Emission [_Emission]        // 自发光色,当不被任何光照所照到时，对象的颜色<br />
            　　　　　　　　}<br />
            　　　　　　　　Lighting On<br />
            　　　　　　　　// 这个命令会添加高光光照到着色器通道的末尾 //<br />
            　　　　　　　　SeparateSpecular On<br />
      　　　　　　　　SetTexture [_MainText]<br />
            　　　　　　　　{<br />
                   　　　　　　　　Combine texture * primary double, texture * primary<br />
            　　　　　　　　}<br />
     　　　　　　　　}<br />
    　　　　　　　　}<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/558630/201309/26180127-00d5283400a140ff9f30c7848f149871.jpg" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4kz59z.html">Linux目录结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g5o787.html">Object是什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93pndn8.html">JavaScript Array和string的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/495ykk0q.html">RAL 标准颜色表（RAL Color Chart）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m961p348.html">大数据下Limit使用&lpar;MySQL&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1rj3x9.html">苹果将通过新Apple TV打造电视游戏平台 欲发力家庭游戏（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1o5vm9.html">TCP&sol;IP协议原理与应用笔记25：网际协议（IP）之 数据报（Datagram）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o2zx49.html">前台添加jquery的引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg50ed8.html">AngularJS &plus; CoffeeScript</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eywwok9.html">ArrayList和LinkedList源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojr305q.html">Android RRO机制的运用-----google开机向导客制化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjkzyl9.html">Notes of Daily Scrum Meeting（12&period;22）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv26mjj9.html">css定位研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvez0nz9.html">Vert&period;x</a>
		</li>
						<li><a href="https://www.batexi.com/a/963yoky9.html">Hessian与Webservice的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/93plvvr8.html">TOMCAT清理</a>
		</li>
						<li><a href="https://www.batexi.com/a/963wzk39.html">Selenium Webdriver&mdash;&mdash;处理Table</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjnk5zq.html">2016-2017-2 20155117实验二《Java面向对象程序设计》实验报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmw3p09.html">第 18 章 Django 入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp00dy9.html">jquery&period;autocomplete修改 实现键盘上下键 自动填充</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvv7zdjq.html">使用webView制作浏览器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmx4d79.html">famous javascript library&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mjndkq.html">eclipse引用头文件报错问题-解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xnjn08.html">带有可点击区域的图像映射：HTML &amp;lt&semi;map&amp;gt&semi; 标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w60loq.html">&lbrack;转&rsqb;Creating Unit Tests for ASP&period;NET MVC Applications &lpar;C&num;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w6303q.html">HTTP层 &mdash;&mdash; CSRF保护</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdzw0z8.html">优雅的使用 PhpStorm 来开发 Laravel 项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0xl2eq.html">MySQL之事务处理、存储过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y63kjq.html">CefSharp开源库的使用&lpar;一&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mj0g1q.html">Sqlserver 安装</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
